#include "p18f45k20.h"

#include "DOGM162.h"

#include "delays.h"

#include "math.h"

void DOGM_Init(void)
{
    DOGM_SI = 0;
    DOGM_CLK = 0;
}

void DOGM_Clear(void)
{
    DOGM_Data(0x01);
}

void DOGM_Data(unsigned int data)
{
    int i = 0;
    char data_bit = 0;
    
    for(i=0; i<8; i++)
    {
        data_bit = (data & 0x80) >> 7;
        data = data << 1;

        DOGM_SI = data_bit;
        Delay100TCYx(100);
        DOGM_CLK = 1;
        Delay100TCYx(100);
        DOGM_CLK = 0;
    }

    DOGM_SI = 0;
}

void DOGM_String(const char *text)
{
    int i = 0;

    for(i=0; i<16; i++)
    {
        Delay100TCYx(100);
        DOGM_Data(text[i]);
    }

    DOGM_Data(0x02);
}

void DOGM_Var(unsigned int variable)
{
    int i = 0;
    int variable_C = 0;
    int variable_D = 0;
    int variable_U = 0;

    variable_C = ceil(variable/100);
    variable_D = ceil((variable-(variable_C*100))/10);
    variable_U = variable-(variable_C*100)-(variable_D*10);

    DOGM_Data(0x56); //V
    Delay100TCYx(100);
    DOGM_Data(0x41); //A
    Delay100TCYx(100);
    DOGM_Data(0x52); //R
    Delay100TCYx(100);
    DOGM_Data(0x49); //I
    Delay100TCYx(100);
    DOGM_Data(0x41); //A
    Delay100TCYx(100);
    DOGM_Data(0x42); //B
    Delay100TCYx(100);
    DOGM_Data(0x4C); //L
    Delay100TCYx(100);
    DOGM_Data(0x45); //E
    Delay100TCYx(100);
    DOGM_Data(0x20); //
    Delay100TCYx(100);
    DOGM_Data(0x3A); //:
    Delay100TCYx(100);
    DOGM_Data(0x20); //
    Delay100TCYx(100);
    DOGM_Data(variable_C+0x30);
    Delay100TCYx(100);
    DOGM_Data(variable_D+0x30);
    Delay100TCYx(100);
    DOGM_Data(variable_U+0x30);
    Delay100TCYx(100);
    DOGM_Data(0x20); //
    Delay100TCYx(100);
    DOGM_Data(0x20); //
    
    DOGM_Data(0x02);
}
