#include "p18f14k22.h"

#include "Interrupts.h"

#include "DOGM162.h"

#include "DOGM162_Driver.h"

unsigned char trame_pos = 0;
unsigned int trame_data = 0x00;

char tmp_aff = 0;

#pragma code InterruptVectorHigh = 0x08
void InterruptVectorHigh (void)
{
  _asm
    goto InterruptServiceHigh
  _endasm
}

#pragma code InterruptVectorLow = 0x18
void InterruptVectorLow (void)
{
  _asm
    goto InterruptServiceLow
  _endasm
}

#pragma interrupt InterruptServiceHigh
void InterruptServiceHigh(void)
{
    
}

#pragma interruptlow InterruptServiceLow
void InterruptServiceLow(void)
{
    if(PIR1bits.CCP1IF)
    {
        PIR1bits.CCP1IF = 0;

        trame_data = trame_data << 1;
        trame_data |= DATA_SI;
        trame_pos++;

        if(trame_pos == 8)
        {
            DOGM_Display(trame_data);
            trame_data = 0x00;
            trame_pos = 0;
        }
    }

    if(INTCONbits.TMR0IF)
    {
        INTCONbits.TMR0IF = 0;

        TMR0H = 0x00;
        TMR0L = 0x00;

        if(tmp_aff < 1)tmp_aff++;
        else
        {
            T0CONbits.TMR0ON = 0;
            PIE1bits.CCP1IE = 1; //Activation interruption
            DOGM_Clear();
        }
    }
}

